--Custom Signpost Frame

local signpodium = {
	SKINCOLOR_MUSTARD,
	SKINCOLOR_SILVER,
	SKINCOLOR_CINNAMON
}

local superpodium = {
	[1] = 	{SKINCOLOR_SUPER1,
			SKINCOLOR_SUPER2,
			SKINCOLOR_SUPER3,
			SKINCOLOR_SUPER4,
			SKINCOLOR_SUPER5},

	[2] = 	{SKINCOLOR_WSUPER1,
			SKINCOLOR_WSUPER2,
			SKINCOLOR_WSUPER3,
			SKINCOLOR_WSUPER4,
			SKINCOLOR_WSUPER5},

	[3] = 	{SKINCOLOR_TSUPER1,
			SKINCOLOR_TSUPER2,
			SKINCOLOR_TSUPER3,
			SKINCOLOR_TSUPER4,
			SKINCOLOR_TSUPER5}
}

local podiumscale = {
	[1] = {1, 1},
	[2] = {3, 4},
	[3] = {1, 2}
}

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end

	local p = mo.target.player
	
	if p.hqsuperfinish then
		if not mo.cycleset then
			mo.podcycle = 1
			mo.cycleset = true
		end
		
		if leveltime%3 == 0 then
			if mo.podcycle >= #superpodium[p.kartstuff[k_position]] then
				mo.podcycle = 1
			else
				mo.podcycle = $ + 1
			end
		end
		mo.color = superpodium[p.kartstuff[k_position]][mo.podcycle]
	else
		mo.color = signpodium[p.kartstuff[k_position]]
	end

end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
		
	if mo.target
	and mo.target.valid
	and mo.target.player then
		local p = mo.target.player
		mo.scale = ((podiumscale[p.kartstuff[k_position]][1])*mapobjectscale)/(podiumscale[p.kartstuff[k_position]][2])
	end
end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
		
	if mo.target.target
	and mo.target.target.valid
	and mo.target.target.player then
		local p = mo.target.target.player
		mo.scale = ((podiumscale[p.kartstuff[k_position]][1])*mapobjectscale)/(podiumscale[p.kartstuff[k_position]][2])
	end
end, MT_OVERLAY)

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	
	for p in players.iterate
		if p.exiting then
			if p.kartstuff[k_position] == 2
			or p.kartstuff[k_position] == 3 then
				if not p.mo.signspawned then
					local exitsign = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+(mapobjectscale*400),MT_SIGN)
					exitsign.target = p.mo
					exitsign.state = S_SIGN1
					exitsign.movefactor = p.mo.floorz
					exitsign.movecount = 1
					p.mo.signspawned = true
				end
			end
		end
	end
end)